      Program NetCDF_Write
      Implicit NONE

c---- Variables to 
      Integer IXMAX,IYMAX,IZMAX
        PARAMETER (IXMAX=31,IYMAX=31,IZMAX=31)
      Double Precision x(1:IXMAX),y(1:IYMAX),z(1:IZMAX)
      Double Precision vx(1:IXMAX,1:IYMAX,1:IZMAX)
     $                ,vy(1:IXMAX,1:IYMAX,1:IZMAX)
     $                ,vz(1:IXMAX,1:IYMAX,1:IZMAX) 
      Double Precision rho(1:IXMAX,1:IYMAX,1:IZMAX)
      Double Precision tk(1:IXMAX,1:IYMAX,1:IZMAX)
      Double Precision sigma(1:IXMAX,1:IYMAX,1:IZMAX)
c$$$      Double Precision tk_init

c---- local variables
      Double Precision      XMAX,  YMAX,  ZMAX
      Double Precision    deltax,deltay,deltaz
      Double Precision    xc,yc,zc
      Integer*4 ix,iy,iz

c---- 
      Integer*4 idf,idn
      Integer*4 idix,idiy,idiz
      Integer*4 mstatus,nf_close

c---- Inpiut Parameter
c---- Define the mesh size.
      
c---- Define the position of mesh cneter.

      XMAX=6.D18
      YMAX=6.D18
      ZMAX=6.D18

      deltax = XMAX/(Real(IXMAX))
      Do ix = 1,IXMAX
         x(ix)=deltax*ix
      End do

      deltay = YMAX/(Real(IYMAX))
      Do iy = 1,IYMAX
         y(iy)=deltay*iy
      End do

      deltaz = ZMAX/(Real(IZMAX))
      Do iz = 1,IZMAX
         z(iz)=deltaz*iz
      End do

c-----  Move the system center to the origin.

      xc = 0.0D0
      Do ix = 1,IXMAX
         xc = xc + x(ix) 
      End do

      yc = 0.0D0
      Do iy = 1,IYMAX
         yc = yc + y(iy) 
      End do

      zc = 0.0D0
      Do iz = 1,IZMAX
         zc = zc + z(iz) 
      End do

      xc = xc/Dble(IXMAX)
      yc = yc/Dble(IYMAX)
      zc = zc/Dble(IZMAX)

      Do ix = 1,IXMAX
         x(ix) = x(ix) - xc
      End do
      Do iy = 1,IYMAX
         y(iy) = y(iy) - yc
      End do
      Do iz = 1,IZMAX
         z(iz) = z(iz) - zc 
      End do


      Do iz = 1,IZMAX
         Do iy = 1,IYMAX
            Do ix = 1,IXMAX
               
c---- Define Density

c$$$               vx(ix,iy,iz) = 0.0D0
c$$$               vy(ix,iy,iz) = 0.0D0
c$$$               vz(ix,iy,iz) = 0.0D0

               vx(ix,iy,iz) = -x(ix)/3.0D18*1.0D5
               vy(ix,iy,iz) = -y(iy)/3.0D18*1.0D5
               vz(ix,iy,iz) = -z(iz)/3.0D18*1.0D5

               If (Sqrt(x(ix)*x(ix)+y(iy)*y(iy)+z(iz)*z(iz)).le.3.0D18)
     &           Then
                  rho(ix,iy,iz)=2.0D3
               Else
                  rho(ix,iy,iz)=1.0D-2

                  vx(ix,iy,iz) = 0.0D0
                  vy(ix,iy,iz) = 0.0D0
                  vz(ix,iy,iz) = 0.0D0

               Endif         

               tk(ix,iy,iz) = 20.0D0
               sigma(ix,iy,iz) = 1.0D5

            End do
         End do
      End do

c---- Define the kinetic temperature.
c$$$      tk_init=20.0D0

c---- All initial variables are defined.
c
c---- Output the initial vatiables with NetCDF.

      write(*,*) IXMAX,IYMAX,IZMAX

      mstatus=nf_close(idf)

      call ncopn3d(idf,'test.cdf',idn,idix,IXMAX,idiy,IYMAX,idiz,IZMAX)

      call ncputosc(idf,'comment','TEST')

      call ncputo1(idf,idix,'x',x,IXMAX)  
      call ncputo1(idf,idiy,'y',y,IYMAX)  
      call ncputo1(idf,idiz,'z',z,IZMAX)  

      call ncputo3(idf,idix,idiy,idiz,'rho',rho   ,IXMAX,IYMAX,IZMAX)
      call ncputo3(idf,idix,idiy,idiz,'vx' ,vx    ,IXMAX,IYMAX,IZMAX)
      call ncputo3(idf,idix,idiy,idiz,'vy' ,vy    ,IXMAX,IYMAX,IZMAX)
      call ncputo3(idf,idix,idiy,idiz,'vz' ,vz    ,IXMAX,IYMAX,IZMAX)
      call ncputo3(idf,idix,idiy,idiz,'tk' ,tk    ,IXMAX,IYMAX,IZMAX)
      call ncputo3(idf,idix,idiy,idiz,'sigma',sigma,IXMAX,IYMAX,IZMAX)

c$$$      call ncputos(idf,'Tk',tk_init)  

      mstatus=nf_close(idf)

c----

      Stop

      End

      
      
