      Subroutine DataCube(Niter)
      Implicit NONE
      
      Include "state.inc"

      Integer*4 Niter
      Integer YN,VBIN2
      Integer ii,jj,kk,ll,nv,nmin

      Real*8 nu0,deltanu,nu,dv(1:VBIN),de,vl
      Real*8 inu(0:IXMAX,0:IYMAX,1:VBIN,0:NLEVMAX-1)
      Real*8 tex(0:IXMAX,0:IYMAX,1:VBIN,0:NLEVMAX-1)
      Real*8 alphanu,jnu,epf
      Real*8 smin,stemp(1:6),temp,temp2(0:NLEVMAX+1)
      Real*8 xtemp(1:6),ytemp(1:6),ztemp(1:6)
      Real*8 aaa,bbb,ccc,ddd
      Real*8 taunu,snu

      Real*8 phi,cosphi,sinphi
      Real*8 th ,costh ,sinth

      Character*8 name,fname

c---- Main      
      Open ( Unit = 18, File='eye',Status ='OLD',Err=99)
      Read(18,*) dirx
      Read(18,*) diry
      Read(18,*) dirz
      Close( Unit = 18 )

      aaa = Sqrt(dirx*dirx+diry*diry+dirz*dirz)
      bbb = Sqrt(dirx*dirx+diry*diry)
      costh = dirz/aaa
      sinth =  bbb/aaa

      If (bbb.eq.0.0D0) Then
         cosphi = 1.0D0
         sinphi = 0.0D0
      Else
         cosphi = dirx/bbb
         sinphi = diry/bbb
      Endif
   
      dirx = sinth*cosphi
      diry = sinth*sinphi
      dirz = costh

      write(*,'(A,3(1X,E15.7))') "Veiw from ",dirx,diry,dirz

      dpx  = dirx*LC
      dpy  = diry*LC
      dpz  = dirz*LC

      Do ii = 1,IXMAX
         Do jj = 1,IYMAX

c--- Set initial point
            px = deltax*(ii-IXMAX/2-1)
            py = deltay*(jj-IYMAX/2-1)
            pz = -RMAX

            aaa =  px*costh-pz*sinth
            bbb =  px*sinth+pz*costh

            px = aaa
            pz = bbb

            aaa = px*cosphi-py*sinphi
            bbb = px*sinphi+py*cosphi

            px = -aaa
            py = -bbb

            aaa  = 1.0D0/Sign((Abs(dirx)+EPSILON),dirx)
            stemp(1) = (xm(0)-px)*aaa
            xtemp(1) = xm(0)
            ytemp(1) = py+stemp(1)*diry
            ztemp(1) = pz+stemp(1)*dirz

            stemp(2) = (xm(IXMAX+1)-px)*aaa
            xtemp(2) = xm(IXMAX+1)
            ytemp(2) = py+stemp(2)*diry
            ztemp(2) = pz+stemp(2)*dirz
            
            aaa  = 1.0D0/Sign((Abs(diry)+EPSILON),diry)
            stemp(3) = (ym(0)-py)*aaa
            xtemp(3) = px+stemp(3)*dirx
            ytemp(3) = ym(0)
            ztemp(3) = pz+stemp(3)*dirz

            stemp(4) = (ym(IYMAX+1)-py)*aaa
            xtemp(4) = px+stemp(4)*dirx
            ytemp(4) = ym(IYMAX+1)
            ztemp(4) = pz+stemp(4)*dirz

            aaa  = 1.0D0/Sign((Abs(dirz)+EPSILON),dirz)
            stemp(5) = (zm(0)-pz)*aaa
            xtemp(5) = px+stemp(5)*dirx
            ytemp(5) = py+stemp(5)*diry
            ztemp(5) = zm(0)

            stemp(6) = (zm(IZMAX+1)-pz)*aaa
            xtemp(6) = px+stemp(6)*dirx
            ytemp(6) = py+stemp(6)*diry
            ztemp(6) = zm(IZMAX+1)

          smin = 1.0D300
          Do kk = 1,6

             If (((xtemp(kk)-xm(0)).ge.0.0D0).and.
     &           ((xtemp(kk)-xm(IXMAX+1)).le.0.0D0)) Then
             If (((ytemp(kk)-ym(0)).ge.0.0D0).and.
     &           ((ytemp(kk)-ym(IYMAX+1)).le.0.0D0)) Then
             If (((ztemp(kk)-zm(0)).ge.0.0D0).and.
     &           ((ztemp(kk)-zm(IZMAX+1)).le.0.0D0)) Then
             If (( stemp(kk).ge.0.0D0).and.
     &           ( stemp(kk).le.smin )) Then
                smin  = stemp(kk)
                nmin  = kk
             Endif
             Endif
             Endif
             Endif

          End do

          px = px+smin*dirx
          py = py+smin*diry
          pz = pz+smin*dirz
          
          If (nmin.eq.1) px = xm(0)
          If (nmin.eq.2) px = xm(IXMAX+1)
          If (nmin.eq.3) py = ym(0)
          If (nmin.eq.4) py = ym(IYMAX+1)
          If (nmin.eq.5) pz = zm(0)
          If (nmin.eq.6) pz = zm(IZMAX+1)

            CALL find_sect

            IPX0=IPX
            IPY0=IPY
            IPZ0=IPZ

            Do ll = 0,NL(NS)
                              
               nu0     = (elev(ll+1)-elev(ll))*INV_PLANCK

               Do nv = 1,VBIN
                  
                  dv(nv)  = DVMAX/Dble(VBIN)*(nv-(VBIN+1)*0.5D0)
                  deltanu = dv(nv)/LC*nu0 
                  nu      = nu0 - deltanu
                  de      = H*nu
                  inu(ii,jj,nv,ll)=2.0D0*de*(nu/LC)**2
     &                                     /(Exp(de*INV_TBG)-1.0D0)

               End do
            End do            

10001       Continue
                  
            CALL path_length

            aaa = INV_SQRT_PI*INV_4PI*HC*inv_sigma(ipx,ipy,ipz)

            Do ll = 0,NL(NS)

               Do nv = 1,VBIN

                  dv(nv) = DVMAX/Dble(VBIN)*(nv-(VBIN+1)*0.5D0)
                  vl = -vx(ipx,ipy,ipz)*dirx
     &                 -vy(ipx,ipy,ipz)*diry
     &                 -vz(ipx,ipy,ipz)*dirz
     &                 -dv(nv)

                  epf= aaa*exp(-(vl*inv_sigma(ipx,ipy,ipz))**2)

             bbb = ndens(ns,ll  ,ipx,ipy,ipz)*B(ns,ll  ,ll+1)
     &            -ndens(ns,ll+1,ipx,ipy,ipz)*B(ns,ll+1,ll  )
             bbb = Sign(Abs(bbb)+EPSILON,bbb)
             
             ccc = ndens(ns,ll+1,ipx,ipy,ipz)*A(ns,ll+1,ll  )

             snu   = ccc/bbb
             taunu = bbb*epf*plen
             
             ddd = Exp(-taunu)

             inu(ii,jj,nv,ll) = inu(ii,jj,nv,ll)*ddd+snu*(1.0D0-ddd)
                  
               End do
               
            End do

            CALL to_next (YN)
            
            If (YN.eq.0) goto 10001

         End do

      End do

      VBIN2 = VBIN
      Call OutputObsCDF(Niter,IXMAX+1,IYMAX+1,VBIN2,inu,dv)
      
c$$$      write(name,'(I4.4)') Niter
c$$$      fname = "DATA"//name
c$$$      Open (Unit=30,File=fname)
c$$$
c$$$      Do nv = 1,VBIN
c$$$         dv(nv)  = DVMAX/Dble(VBIN)*(nv-(VBIN+1)*0.5D0)
c$$$         Do ll = 0,NL(NS)
c$$$            nu0     = (elev(ll+1)-elev(ll))*INV_PLANCK
c$$$            deltanu = dv(nv)/LC*nu0 
c$$$            nu      = nu0 - deltanu
c$$$            Do jj = 1,IYMAX
c$$$               Do ii = 1,IXMAX
c$$$                  tex(ii,jj,nv,ll) = h*nu/KB
c$$$     &            /(log(2.0D0*h*nu**3/(LC*LC*inu(ii,jj,nv,ll))+1.0D0))
c$$$               End do
c$$$            End do
c$$$         End do
c$$$      
c$$$      End do
c$$$
c$$$      Close(Unit=30)
c$$$
c$$$      Stop

      Return

 99   Continue
      write(*,*) "File eye is missing."
      Stop

      End

      Subroutine OutputObsCDF(Niter,IXM,IYM,VBIN2,inu,dv)
      Implicit NONE

      Include 'state.inc'
c---- Inputs
      Integer Niter,VBIN2
      Integer IXM,IYM
      Real*8  inu(0:IXM-1,0:IYM-1,1:VBIN2,0:NLEVMAX-1)
      Real*8   dv(1:VBIN2)

c---- local variables
      Integer*4 ii,jj,nv,ll

      Real*8     xwrite(1:IXM),ywrite(1:IYM)
      Real*8     inuwrite(1:IXM,1:IYM,1:VBIN2)
      
      Integer*4 idf,idn
      Integer*4 idix,idiy,idnv
      Integer*4 mstatus

      Character*4 name
      Character*9 fname1
      Character*14 fname2
      Character*8 lvname

      Include "netcdf.inc"

      Real*8 nu0,deltanu,nu,de,vl
      Real*8 tex(0:IXM,0:IYM,1:VBIN2,0:NLEVMAX-1)

c---- main

      write(name,'(I4.4)') Niter
      fname1 = "DATAC"//name
      fname2 = fname1//'.cdf'

      mstatus=nf_open(fname2,0,idf)

      call ncopn3d(idf,fname2,idn,idix,IXM,idiy,IYM,idnv,VBIN2)

      call ncputosc(idf,'comment','Intensity')
      call ncputosc(idf,'Molecule','molecule')
      
      call ncputos(idf,'XMAX',XMAX)
      call ncputos(idf,'YMAX',YMAX)
      call ncputos(idf,'DVMAX',DVMAX*0.5D0)

      call ncputos(idf,'XMIN',XMIN)
      call ncputos(idf,'YMIN',YMIN)
      call ncputos(idf,'DVMIN',-DVMAX*0.5D0)

      call ncputos(idf,'dirx',dirx)
      call ncputos(idf,'diry',diry)
      call ncputos(idf,'dirz',dirz)

      Do ii = 0,IXMAX
         xwrite(ii+1) = x(ii)
      End do
      Do jj = 0,IYMAX
         ywrite(jj+1) = y(jj)
      End do
      call ncputo1(idf,idix,'x' ,xwrite,IXM)  
      call ncputo1(idf,idiy,'y' ,ywrite,IYM)  
      call ncputo1(idf,idnv,'dv',dv   ,VBIN2)  

      Do ll = 0,NLEVMAX-1
         Do ii = 0,IXMAX
            Do jj = 0,IYMAX
               Do nv = 1,VBIN2
                  inuwrite(ii+1,jj+1,nv) = inu(ii,jj,nv,ll)
               End do
            End do
         End do

         write(name,'(I4.4)') ll
         lvname = "LV"//name
         call ncputo3(idf,idix,idiy,idnv,lvname,
     &                            inuwrite,IXM,IYM,VBIN2)

      End do

      mstatus=nf_close(idf)

      write(*,*) "Datacube is written : ",fname2
      
      Return

      End

c$$$      Subroutine testREAD(VBIN)
c$$$      Implicit NONE
c$$$      Include 'state.inc'
c$$$
c$$$      Integer IXM,IYM,VBIN,ii,jj,nv,ll
c$$$
c$$$      Real*8     xread(1:31)
c$$$      Real*8     yread(1:31)
c$$$      Real*8     dv(1:31)
c$$$      Real*8  inu(0:30,0:30,1:31,0:NLEVMAX-1)
c$$$      Real*8     inuwrite(1:31,1:31,1:31)
c$$$
c$$$      Character*64 inputfile
c$$$
c$$$      Integer*4 idf,idn
c$$$      Integer*4 idix,idiy,idnv
c$$$      Integer*4 mstatus
c$$$
c$$$      Character*4 name
c$$$      Character*8 fname1
c$$$      Character*12 fname2
c$$$      Character*8 lvname
c$$$
c$$$      INCLUDE 'netcdf.inc'
c$$$      
c$$$      Real*8 nu0,deltanu,nu,de,vl
c$$$      Real*8 tex(0:IXMAX,0:IYMAX,1:VBIN,0:NLEVMAX-1)
c$$$
c$$$c---- Main
c$$$      IXM = 31
c$$$      IYM = 31
c$$$
c$$$      inputfile = "sample.cdf"
c$$$      write(*,*) "Input file is ", inputfile
c$$$
c$$$      mstatus=nf_open(inputfile,0,idf)
c$$$
c$$$      call ncgetos(idf,'XMAX',XMAX)
c$$$      call ncgetos(idf,'YMAX',YMAX)
c$$$      call ncgetos(idf,'XMIN',XMIN)
c$$$      call ncgetos(idf,'YMIN',YMIN)
c$$$
c$$$      call ncgetos(idf,'DVMAX',DVMAX)
c$$$      DVMAX = DVMAX*2.0D0
c$$$      
c$$$      call ncgetos(idf,'dirx',dirx)
c$$$      call ncgetos(idf,'diry',diry)
c$$$      call ncgetos(idf,'dirz',dirz)
c$$$
c$$$      call ncgeto1(idf,'x',xread,IXM)
c$$$      call ncgeto1(idf,'y',yread,IYM)
c$$$      call ncgeto1(idf,'dv',dv,VBIN)
c$$$      Do ii = 0,IXMAX
c$$$         x(ii) = xread(ii+1) 
c$$$      End do
c$$$      Do jj = 0,IYMAX
c$$$         y(jj) = yread(jj+1) 
c$$$      End do
c$$$
c$$$      Do ll = 0,NLEVMAX-1
c$$$         write(name,'(I4.4)') ll
c$$$         lvname = "LV"//name
c$$$         write(*,*) 'Read ',lvname
c$$$
c$$$         call ncgeto3(idf,lvname,inuwrite,IXM,IYM,VBIN)
c$$$
c$$$         Do ii = 0,IXMAX
c$$$            Do jj = 0,IYMAX
c$$$               Do nv = 1,VBIN
c$$$                  inu(ii,jj,nv,ll) = inuwrite(ii+1,jj+1,nv)
c$$$               End do
c$$$            End do
c$$$         End do
c$$$
c$$$      End do
c$$$
c$$$      Do nv = 1,VBIN
c$$$         write(203,'(6(1X,E15.7))') dv(nv)/1.0D5,
c$$$     &                  (inu(IXMAX/2+5,IYMAX/2,nv,ll),ll=0,5)
c$$$      End do
c$$$
c$$$      fname1 = "DATATEST"
c$$$      Open (Unit=30,File=fname1)
c$$$
c$$$      Do nv = 1,VBIN
c$$$         dv(nv)  = DVMAX/Dble(VBIN)*(nv-(VBIN+1)*0.5D0)
c$$$         Do ll = 0,NL(NS)
c$$$            nu0     = (elev(ll+1)-elev(ll))*INV_PLANCK
c$$$            deltanu = dv(nv)/LC*nu0 
c$$$            nu      = nu0 - deltanu
c$$$            Do jj = 1,IYMAX
c$$$               Do ii = 1,IXMAX
c$$$                  tex(ii,jj,nv,ll) = h*nu/KB
c$$$     &            /(log(2.0D0*h*nu**3/(LC*LC*inu(ii,jj,nv,ll))+1.0D0))
c$$$               End do
c$$$            End do
c$$$         End do
c$$$      
c$$$         write(30,'(6(1X,E15.7))') dv(nv)/1.0D5,
c$$$     &                  (tex(IXMAX/2+5,IYMAX/2,nv,ll),ll=0,5)
c$$$                            
c$$$      End do
c$$$
c$$$      Close(Unit=30)
c$$$
c$$$      Stop
c$$$
c$$$      Return
c$$$      End
 
      
