      Subroutine LineProfile(Niter)
      Implicit NONE
      
      Integer*4 Niter
      Include "state.inc"
      Integer IMAX,JMAX,YN
        Parameter(IMAX=1,JMAX=1)
      Integer ii,jj,kk,ll,nv,nmin

      Real*8 nu0,deltanu,nu,dv,de,vl
      Real*8 inu(1:VBIN,0:NLEVMAX-1,0:IMAX,0:JMAX)
      Real*8 alphanu,jnu,epf
      Real*8 smin,stemp(1:6),temp,temp2(0:NLEVMAX+1)
      Real*8 aaa,bbb,ccc,ddd
      Real*8 taunu,snu

      Character*8 name,fname

      dirx = 1.0D0
      diry = 0.0D0
      dirz = 0.0D0
      
      dpx  = dirx*LC
      dpy  = diry*LC
      dpz  = dirz*LC

      Do ii = 1,IMAX
         Do jj = 1,JMAX

            px = -RMAX*dirx 
            py = -RMAX*diry + deltay*(ii-IMAX/2-1)+5
            pz = -RMAX*dirz + deltaz*(jj-JMAX/2-1)

            aaa  = 1.0D0/Sign(Abs(dirx)+EPSILON,dirx)
            stemp(1) = (xm(0)-px)*aaa
            stemp(2) = (xm(IXMAX+1)-px)*aaa

            aaa  = 1.0D0/Sign(Abs(diry)+EPSILON,diry)
            stemp(3) = (ym(0)-py)*aaa
            stemp(4) = (ym(IYMAX+1)-py)*aaa

            aaa  = 1.0D0/Sign(Abs(dirz)+EPSILON,dirz)
            stemp(5) = (zm(0)-pz)*aaa
            stemp(6) = (zm(IZMAX+1)-pz)*aaa

            smin = 1.0D300
            Do kk = 1,6
               If ((stemp(kk).gt.0.0D0).and.(stemp(kk).lt.smin)) Then
                  smin  = stemp(kk)
                  nmin  = kk
               Endif
            End do

            px = px+smin*dirx
            py = py+smin*diry
            pz = pz+smin*dirz

            If (nmin.eq.1) px = xm(0)
            If (nmin.eq.2) px = xm(IXMAX+1)
            If (nmin.eq.3) py = ym(0)
            If (nmin.eq.4) py = ym(IYMAX+1)
            If (nmin.eq.5) pz = zm(0)
            If (nmin.eq.6) pz = zm(IZMAX+1)

            CALL find_sect

            IPX0=IPX
            IPY0=IPY
            IPZ0=IPZ

            Do ll = 0,NL(NS)
                              
               nu0     = (elev(ll+1)-elev(ll))*INV_PLANCK

               Do nv = 1,VBIN
                  
                  dv  = DVMAX/Dble(VBIN)*(nv-(VBIN+1)*0.5D0)
                  deltanu = dv/LC*nu0 
                  nu      = nu0 - deltanu
                  de      = H*nu
                  inu(nv,ll,ii,jj)=2.0D0*de*(nu/LC)**2
     &                                     /(Exp(de*INV_TBG)-1.0D0)

               End do
            End do            

10001       Continue
                  
            CALL path_length

            aaa = INV_SQRT_PI*INV_4PI*HC*inv_sigma(ipx,ipy,ipz)

            Do ll = 0,NL(NS)

               Do nv = 1,VBIN

                  dv = DVMAX/Dble(VBIN)*(nv-(VBIN+1)*0.5D0)
                  vl = -vx(ipx,ipy,ipz)*dirx
     &                 -vy(ipx,ipy,ipz)*diry
     &                 -vz(ipx,ipy,ipz)*dirz
     &                 -dv

                  epf= aaa*exp(-(vl*inv_sigma(ipx,ipy,ipz))**2)

             bbb = ndens(ns,ll  ,ipx,ipy,ipz)*B(ns,ll  ,ll+1)
     &            -ndens(ns,ll+1,ipx,ipy,ipz)*B(ns,ll+1,ll  )
             bbb = Sign(Abs(bbb)+EPSILON,bbb)
             
             ccc = ndens(ns,ll+1,ipx,ipy,ipz)*A(ns,ll+1,ll  )

             snu   = ccc/bbb
             taunu = bbb*epf*plen
             
             ddd = Exp(-taunu)

             inu(nv,ll,ii,jj) = inu(nv,ll,ii,jj)*ddd
     &                         +snu*(1.0D0-ddd)
                  
               End do
               
            End do

            CALL to_next (YN)
            
            If (YN.eq.0) goto 10001

         End do

      End do

      write(name,'(I4.4)') Niter
      fname = "Line"//name

      Open (Unit=30,File=fname)

      Do nv = 1,VBIN
         dv  = DVMAX/Dble(VBIN)*(nv-(VBIN+1)*0.5D0)
         Do ll = 0,NL(NS)
            nu0     = (elev(ll+1)-elev(ll))*INV_PLANCK
            deltanu = dv/LC*nu0 
            nu      = nu0 - deltanu

            temp = 0.0D0
            Do ii = 1,IMAX
               Do jj = 1,JMAX
                  
                  temp = temp + inu(nv,ll,ii,jj)
                  
               End do
            End do
            temp2(ll) = temp/Dble(IMAX*JMAX)
      temp2(ll) = h*nu/KB/(log(2.0D0*h*nu**3/(LC*LC*temp2(ll))+1.0D0))

         End do
         
         aaa = Min(5,NL(NS))
         
      write(30,'(6(1X,E15.7))') dv/1.0D5,( temp2(ll),ll=0,aaa)

      End do

      Close(Unit=30)

      Return
      End
