C**********************************************************************
C NAME:
C	NonLTE1-1.f 
C PORPUS:
C MODIFICATION HISTORY:
C      Thu Nov 18 15:34:00 JST 2000 K. Saigo
C      Thu Mar 29 20:02:23 JST 2001 K. Saigo
C      Thu Mar 28 10:32:33 JST 2003 Y. Imaeda
C***********************************************************************

c---- Modified by Imaeda
      Program NonLTE
      Implicit NONE

      Integer N
      Real tmp
c----
      INCLUDE 'state.inc'
      INCLUDE 'ran.inc'
      character*1000 fn
      INTEGER YN
      INTEGER Niter,Np_max,Np_max_BG

      Integer flag

      Integer IX,IY,IZ
      Integer J

c---- Main
      IDUM=-3159
      tmp=RAN1(IDUM)

      Call InputParameter
c--- test for no inpt data
c$$$      If (TABLENAME.eq.'CO-H2para.dat') Then
c$$$         Call SetupCO
c$$$      Elseif (TABLENAME.eq.'HCO+-H2.dat') Then
c$$$         Call SetupHCOplus
c$$$      Else
c$$$         write(*,*) 'File does not exist!'
c$$$         Stop
c$$$      Endif
c---

      If (VIEWPROCESS.eq.1) Then
         Call ReadIterationDATA

         Niter = 0
         Call DataCube(Niter)
         Stop
      Else
         Call ReadInputData
      Endif

      Np_max=(IXMAX+1)*(IYMAX+1)*(IZMAX+1)*NRAY
      Np_max_BG = Np_max
      write(*,*) 'The number of photonpackage is ',Np_max
      
c     Call CPU_Time(tuser)
      tsystem=0.0D0

c---- Start iteration
      DO 200 Niter=1,10000

c---- The beginning of Photon Package Calculation
         DO 100 N=1,Np_max
            
c----       Generate a Photon Package
            CALL generate_photon(Np_max)
            If (ndens0(0,ipx,ipy,ipz).gt.1.0D-10) Then 

c----       Propagate the photon package
 2          CONTINUE

               CALL path_length
               CALL cal_s(Niter)
               CALL to_next (YN)

            IF (YN.EQ.0) goto 2

            Endif

 100     CONTINUE
c---- The end of Photon Package Calculation

c---- For back ground photon calculation
         Do N=1,Np_max_BG

            Call generate_photon_BG(Np_max_BG,flag)

            If (flag.eq.0) Then
 101        Continue
               CALL path_length
               CALL cal_s_bg(Niter)
               CALL to_next (YN)

            IF (YN.EQ.0) goto 101
            Endif

         End do
c---- The end of back ground calculation

c---- Update level population 
         CALL Adjust_Population(Niter)

c---- Elapsed time
         tuser_prev   = tuser
         tsystem_prev = tsystem
c        Call CPU_Time(tuser)
         tsystem=0.0D0

c---- File out 
         
          Open ( Unit = 17, File='outputcontrol',Status ='OLD',Err=99)
          Read(17,*) ixout,iyout,izout
          Read(17,*) displayflag
          If (displayflag  .ne.0) Call DisplayOut(Niter)
          Read(17,*) iterationflag
          If (iterationflag.ne.0) Call IterationOut(Niter)
          Read(17,*) texflag
          If (texflag      .ne.0) Call TexOut(Niter)
          Read(17,*) lineflag
          If (lineflag     .ne.0) Call LineProfile(Niter)
          Read(17,*) outflag
          If (outflag      .ne.0) 
     &         Call OutputCDF(Niter,IXMAX+1,IYMAX+1,IZMAX+1)
          Read(17,*) outflag
          If (dcubeflag    .ne.0) 
     &         Call OutputCDF(Niter,IXMAX+1,IYMAX+1,IZMAX+1)
          Close( Unit = 17 )
          
 200  CONTINUE
 99   Continue

      Niter = 0
      Call OutputCDF(Niter,IXMAX+1,IYMAX+1,IZMAX+1)
      
      Stop
      
      End


      Subroutine generate_photon(Np_max)
c---- Modified by Imaeda
      Implicit NONE
      Integer IX,IY,IZ
      Integer J

      Integer Np_Max

      Real*8 inv
c----
      INCLUDE 'state.inc'
      INCLUDE 'ran.inc'
      Real*8 PNORM,inv_norm
      Real*8 DX,DY,DZ
      Real*8 theta,phi,rr
      Real*8 delta_e,epf,aaa,absc,inv_absc,tau
      Real*8 fact

      Integer*4 ii,jj,count(0:50)
C----- Select a Transition

      DX = XMAX-XMIN
      DY = YMAX-YMIN
      DZ = ZMAX-ZMIN

      PX=XMIN+DX*RAN1(IDUM)      
      PY=YMIN+DY*RAN1(IDUM)     
      PZ=ZMIN+DZ*RAN1(IDUM)     

C----- the angle of propagation

      phi   = RAN1(IDUM)*PI*2
      theta = RAN1(IDUM)*PI

      dirx  = sin(theta)*cos(phi)
      diry  = sin(theta)*sin(phi)
      dirz  = cos(theta)
     
      dpx  = dirx*LC
      dpy  = diry*LC
      dpz  = dirz*LC

      CALL find_sect

C ----- Initial Cell Position Number (IPX0,IPY0,IPZ0)
      IPX0=IPX
      IPY0=IPY
      IPZ0=IPZ

      fact = Dble((IXMAX+1)*(IYMAX+1)*(IZMAX+1))/Dble(Np_max)

c---- Consider All population levels with one photon packet.
      Do j = 1,NL(NS)    ! From 1->0  to NL(NS) -> NL(NS)-1

         nphoton0(j) = ndens(NS,j,ipx0,ipy0,ipz0)*VCELL*A(NS,j,j-1)*fact
         nphoton(j)  = nphoton0(j)

         nphoton0_ref(j) = ndens_ref(NS,j,ipx0,ipy0,ipz0)
     &                                           *VCELL*A(NS,j,j-1)*fact
         nphoton_ref (j) = nphoton0_ref(j)

      End do

c--- Gaussian randam
      rr    = RAN1(IDUM)
      phi   = RAN1(IDUM)*PI
      dnu = Sqrt(-Log(rr))*Cos(phi)

      Return
      End 


      Subroutine generate_photon_BG(Np_max_BG,flag)
      Implicit NONE
      Integer IX,IY,IZ
      Integer J

      Integer Np_Max_BG,flag

      Real*8 inv
      INCLUDE 'state.inc'
      INCLUDE 'ran.inc'
      Real*8 PNORM,inv_norm
      Real*8 DX,DY,DZ

      Real*8 theta,phi,rr
      Real*8 delta_e,epf,aaa,bbb,absc,inv_absc,tau
      Real*8 fact,tmin

      Real*8 stemp,xtemp,ytemp,ztemp
      Integer kk,nmax
      Real*8 nu,nu0

      Real*8 cphi ,sphi ,ctheta,stheta
      Real*8 cbeta,sbeta,calpha,salpha
      Real*8 alpha,beta


      Real*8 ra(1:6)
      Integer*4 seed,SIZE
c---- Main
      
      flag = 0
 3001 Continue

      phi   = RAN1(IDUM)*PI*2

      cphi  = cos(phi)
      sphi  = sin(phi)
      ctheta = 2.0D0*RAN1(IDUM)-1.0D0
      stheta = Sqrt(1.0D0-ctheta*ctheta)

      dirx  = cphi*stheta
      diry  = sphi*stheta
      dirz  = ctheta

 1111 Continue
      alpha = RMAX*(2.0D0*RAN1(IDUM)-1.0D0)
      beta  = RMAX*(2.0D0*RAN1(IDUM)-1.0D0)
      If (alpha*alpha+beta*beta.gt.RMAX*RMAX) Goto 1111

      px    = alpha*cphi*ctheta - beta*sphi
      py    = alpha*sphi*ctheta + beta*cphi
      pz    =-alpha     *stheta
     
      dpx  = dirx*LC
      dpy  = diry*LC
      dpz  = dirz*LC

      If (dirx.gt.0.0D0) Then
         xtemp = xm(0)
      Elseif(dirx.lt.0.0D0) Then
         xtemp = xm(IXMAX+1)
      Else
         xtemp = 1.0D+50
      Endif
      aaa  = 1.0D0/Sign(Abs(dirx)+EPSILON,dirx)
      stemp = (xtemp-px)*aaa
      ytemp = py + stemp*diry
      ztemp = pz + stemp*dirz
      If ( (((ytemp-YMAX)*(ytemp-YMIN)).le.0.0D0).and.
     &     (((ztemp-ZMAX)*(ztemp-ZMIN)).le.0.0D0)) goto 101


      If (diry.gt.0.0D0) Then
         ytemp = ym(0)
      Elseif(diry.lt.0.0D0) Then
         ytemp = ym(IYMAX+1)
      Else
         ytemp = 1.0D+50
      Endif
      aaa  = 1.0D0/Sign(Abs(diry)+EPSILON,diry)
      stemp = (ytemp-py)*aaa
      ztemp = pz + stemp*dirz
      xtemp = px + stemp*dirx
      If ( (((ztemp-ZMAX)*(ztemp-ZMIN)).le.0.0D0).and.
     &     (((xtemp-XMAX)*(xtemp-XMIN)).le.0.0D0)) goto 101


      If (dirz.gt.0.0D0) Then
         ztemp = zm(0)
      Elseif(dirz.lt.0.0D0) Then
         ztemp = zm(IZMAX+1)
      Else
         ztemp = 1.0D+50
      Endif
      aaa  = 1.0D0/Sign(Abs(dirz)+EPSILON,dirz)
      stemp = (ztemp-pz)*aaa
      xtemp = px + stemp*dirx
      ytemp = py + stemp*diry
      If ( (((xtemp-XMAX)*(xtemp-XMIN)).le.0.0D0).and.
     &     (((ytemp-YMAX)*(ytemp-YMIN)).le.0.0D0)) goto 101

c---- If any conditions are not satisfied, flag = 1
      flag=1

 101  Continue

      px = xtemp
      py = ytemp
      pz = ztemp

      deltav = (RAN1(IDUM)-0.5D0)*DVMAX

      Call find_sect

C ----- Initial Cell Position Number (IPX0,IPY0,IPZ0)

      IPX0=IPX
      IPY0=IPY
      IPZ0=IPZ

      fact = 8*PI*PI*RMAX*RMAX/Dble(Np_max_BG)*DVMAX

c---- Consider All population levels with one photon packet.

      Do j = 1,NL(NS)    ! From 1->0  to NL(NS) -> NL(NS)-1

         nu0 = (elev(j)-elev(j-1))*INV_PLANCK
         nu  = nu0*(1.0D0+deltav/LC)
         aaa = nu*INV_LC 
         aaa = aaa*aaa*aaa*fact
         nphoton0(j)=aaa/(Exp(h*nu*INV_TBG)-1.0D0)
         nphoton (j)=nphoton0(j)
         nphoton0_ref(j)=aaa/(Exp(h*nu*INV_TREF)-1.0D0)
         nphoton_ref (j)=nphoton0_ref(j)

      End do

      Return
      End

      Subroutine find_sect
      Implicit NONE
      Integer IX,IY,IZ
      Integer J
      INCLUDE 'state.inc'

C ------ find section (coodinates)
      IPX=0
      IPZ=0
      IPY=0
      DO 300 IX=0,IXMAX
         IF(XM(IX).LE.PX) IPX=IX
 300  CONTINUE
      DO 320 IY=0,IYMAX
         IF(YM(IY).LE.PY) IPY=IY
 320  CONTINUE
      DO 330 IZ=0,IZMAX
         IF(ZM(IZ).LE.PZ) IPZ=IZ
 330  CONTINUE

      RETURN
      END


      SUBROUTINE cal_s(Niter)
c---- Modified by Imaeda
      Implicit NONE
      Integer IX,IY,IZ
      Integer J
      Integer Niter

      Real*8 EPF,delta_nu
c----
      INCLUDE 'state.inc'
      Real*8 ARG,FDLEV,NV
      Real*8 TAU1,tau1_s1

      Real*8 v_parallel,tau,exp_tau,tau_ref,exp_tau_ref
      Real*8 delta_e,absc,inv_absc,aaa,bbb
      
      Real*8 vl
      Real*8 inv_delta_nu

      Integer i

      vl =((vx(ipx,ipy,ipz)-vx(ipx0,ipy0,ipz0))*dirx
     &    +(vy(ipx,ipy,ipz)-vy(ipx0,ipy0,ipz0))*diry
     &    +(vz(ipx,ipy,ipz)-vz(ipx0,ipy0,ipz0))*dirz)
       
C ---- Normalized Emission Profile Function
      DO 100 J=0,NL(NS)-1

        delta_e = elev(j+1)-elev(j)

c---- delta_new is doppler shift in frequency.
        inv_delta_nu = HC*inv_sigma(ipx,ipy,ipz)/delta_e
        epf = INV_SQRT_PI*inv_delta_nu
     &                   *exp(-(vl*inv_sigma(ipx,ipy,ipz)+dnu)**2)

        aaa = INV_4PI*delta_e*epf

        absc     = ( ndens(ns,j  ,ipx,ipy,ipz)*B(ns,j  ,j+1)
     &              -ndens(ns,j+1,ipx,ipy,ipz)*B(ns,j+1,j  ))*aaa

        inv_absc = 1.0D0/(absc+1.0D-300)

        tau      = absc*plen
        exp_tau  = Exp(-tau)

        s = aaa* B(ns,j,j+1) * inv_vcell * 
     &          nphoton(j+1) * inv_absc  * ( 1.0D0 - exp_tau )

        nphoton(j+1) = nphoton(j+1)*exp_tau

c---- For Ref Field
        absc     = ( ndens_ref(ns,j  ,ipx,ipy,ipz)*b(ns,j  ,j+1)
     &              -ndens_ref(ns,j+1,ipx,ipy,ipz)*b(ns,j+1,j  ))*aaa

        inv_absc = 1.0D0/(absc+1.0D-300)

        tau_ref      = absc*plen
        exp_tau_ref  = Exp(-tau_ref)

        s_ref = aaa* B(ns,j,j+1) * inv_vcell * 
     &       nphoton_ref(j+1) * inv_absc  * ( 1.0D0 - exp_tau_ref )

        nphoton_ref(j+1) = nphoton_ref(j+1)*exp_tau_ref

        dss (j,ipx,ipy,ipz) = dss (j,ipx,ipy,ipz) + s
        dss2(j,ipx,ipy,ipz) = dss2(j,ipx,ipy,ipz) + s - s_ref

c----
 100  CONTINUE
      
      RETURN
      END


      SUBROUTINE cal_s_bg(Niter)
c---- Modified by Imaeda
      Implicit NONE
      Integer IX,IY,IZ
      Integer J
      Integer Niter

      Real*8 EPF,delta_nu
c----
      INCLUDE 'state.inc'
      Real*8 ARG,FDLEV,NV
      Real*8 TAU1,tau1_s1

      Real*8 v_parallel,tau,exp_tau,tau_ref,exp_tau_ref
      Real*8 delta_e,absc,inv_absc,aaa,bbb
      
      Real*8 vl
      Real*8 inv_delta_nu
      Integer i

      vl = (vx(ipx,ipy,ipz)-VXG)*dirx
     &    +(vy(ipx,ipy,ipz)-VYG)*diry
     &    +(vz(ipx,ipy,ipz)-VZG)*dirz

C ---- Normalized Emission Profile Function
      DO 100 J=0,NL(NS)-1

        aaa = INV_4PI*INV_SQRT_PI*inv_sigma(ipx,ipy,ipz)*HC
     &               *exp(-((deltav-vl)*inv_sigma(ipx,ipy,ipz))**2)

        absc     = ( ndens(ns,j  ,ipx,ipy,ipz)*b(ns,j  ,j+1)
     &              -ndens(ns,j+1,ipx,ipy,ipz)*b(ns,j+1,j  ))*aaa

        inv_absc = 1.0D0/(absc+1.0D-300)

        tau      = absc*plen
        exp_tau  = Exp(-tau)
        
        s = aaa* B(ns,j,j+1) * inv_vcell * 
     &          nphoton(j+1) * inv_absc  * ( 1.0D0 - exp_tau )

        nphoton(j+1) = nphoton(j+1)*exp_tau

c---- For Ref Field
        absc     = ( ndens_ref(ns,j  ,ipx,ipy,ipz)*b(ns,j  ,j+1)
     &              -ndens_ref(ns,j+1,ipx,ipy,ipz)*b(ns,j+1,j  ))*aaa

        inv_absc = 1.0D0/(absc+1.0D-300)

        tau_ref      = absc*plen
        exp_tau_ref  = Exp(-tau_ref)

        s_ref = aaa* B(ns,j,j+1) * inv_vcell * 
     &       nphoton_ref(j+1) * inv_absc  * ( 1.0D0 - exp_tau_ref )

        nphoton_ref(j+1) = nphoton_ref(j+1)*exp_tau_ref

           dss (j,ipx,ipy,ipz) = dss (j,ipx,ipy,ipz) + s
           dss2(j,ipx,ipy,ipz) = dss2(j,ipx,ipy,ipz) + s - s_ref

c----
 100  CONTINUE
      
      RETURN
      END


      SUBROUTINE path_length
c---- Modified by Imaeda
      Implicit NONE
      Integer IX,IY,IZ
      Integer J,N
      Integer NMIN
c----
      INCLUDE 'state.inc'
      Real*8 DTTMP(6),DTMIN
      INTEGER DIX(6),DIY(6),DIZ(6)
      DATA  DIX/-1, 1, 0, 0, 0, 0/
      DATA  DIY/ 0, 0,-1, 1, 0, 0/
      DATA  DIZ/ 0, 0, 0, 0,-1, 1/
C   
C ======= the path length to the next cell boundary
      DO 100 N=1,6
         DTTMP(N)=0.D0 
 100  CONTINUE
      IF (DPX.NE.0) THEN 
        DTTMP(1)=(XM(IPX)  -PX)/DPX        
        DTTMP(2)=(XM(IPX+1)-PX)/DPX
      ENDIF
      IF (DPY.NE.0) THEN 
        DTTMP(3)=(YM(IPY)  -PY)/DPY        
        DTTMP(4)=(YM(IPY+1)-PY)/DPY        
      ENDIF
      IF (DPZ.NE.0) THEN 
        DTTMP(5)=(ZM(IPZ)  -PZ)/DPZ        
        DTTMP(6)=(ZM(IPZ+1)-PZ)/DPZ        
      ENDIF
      DTMIN=1.D70
      NMIN=0
      DO 150 N=1,6
         IF ((DTTMP(N).GT.0.0D0).AND.(DTTMP(N).LT.DTMIN)) THEN
            DTMIN=DTTMP(N)
            NMIN=N
         ENDIF
 150  CONTINUE


      DT=DTTMP(NMIN)

C ---- the path length to next cell boundary 
      PLEN=DT*LC
C
C ---- Initial position in the next cell (PX2,PY2,PZ2)
      PX2=PX+DT*DPX
      PY2=PY+DT*DPY
      PZ2=PZ+DT*DPZ
      IPX2=IPX+DIX(NMIN)
      IPY2=IPY+DIY(NMIN)
      IPZ2=IPZ+DIZ(NMIN)

c---- Modified by Imaeda: Exact Definition of Next position is needed!
      
      If (NMIN.eq.1) PX2 = XM(IPX)
      If (NMIN.eq.2) PX2 = XM(IPX+1)
      If (NMIN.eq.3) PY2 = YM(IPY)
      If (NMIN.eq.4) PY2 = YM(IPY+1)
      If (NMIN.eq.5) PZ2 = ZM(IPZ)
      If (NMIN.eq.6) PZ2 = ZM(IPZ+1)

      RETURN
      END


      SUBROUTINE to_next(YN)
c---- Modified by Imaeda
      Implicit NONE
      Integer IX,IY,IZ
c----
      INCLUDE 'state.inc'
      INTEGER YN
      YN=0

      IF (ipx2.eq.-1     ) YN=1
      IF (ipy2.eq.-1     ) YN=1
      IF (ipz2.eq.-1     ) YN=1

      IF (ipx2.eq.IXMAX+1) YN=1
      IF (ipy2.eq.IYMAX+1) YN=1
      IF (ipz2.eq.IXMAX+1) YN=1

c$$$      IF (NPHOTON.LT.1.D-5*NPHOTON0) YN=1 

      IPX=IPX2
      IPY=IPY2
      IPZ=IPZ2
      PX=PX2
      PY=PY2
      PZ=PZ2

      RETURN
      END


      FUNCTION ran1(idum)
      Implicit NONE

      INTEGER idum,IA,IM,IQ,IR,NTAB,NDIV
      REAL ran1,AM,EPS,RNMX
      PARAMETER (IA=16807,IM=2147483647,AM=1./IM,IQ=127773,IR=2836,
     $           NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2e-7,RNMX=1.-EPS)
      INTEGER j,k,iv(NTAB),iy
      SAVE iv,iy
      DATA iv /NTAB*0/, iy /0/
      if (idum.le.0.or.iy.eq.0) then
        idum=max(-idum,1)
        do 11 j=NTAB+8,1,-1
          k=idum/IQ
          idum=IA*(idum-k*IQ)-IR*k
          if (idum.lt.0) idum=idum+IM
          if (j.le.NTAB) iv(j)=idum
11      continue
        iy=iv(1)
      endif
      k=idum/IQ
      idum=IA*(idum-k*IQ)-IR*k
      if (idum.lt.0) idum=idum+IM
      j=1+iy/NDIV
      iy=iv(j)
      iv(j)=idum
      ran1=min(AM*iy,RNMX)
      return
      END

      Subroutine Adjust_Population(Niter)
      Implicit NONE

      Integer*4 Niter
      Integer ix,iy,iz
      Integer i,j,n
c----
      INCLUDE 'state.inc'

      Real*8 fact
      Real*8 income,outgo

      Real*8 deltae
c---- variables for matrix
      Real*8 matrix(-1:NLEVMAX+1,-1:NLEVMAX+1)
      Real*8 a_vec(0:NLEVMAX),b_vec(0:NLEVMAX)
      Real*8 e_vec (0:NLEVMAX,0:NLEVMAX),e_vec1(0:NLEVMAX,0:NLEVMAX)
      Real*8 e_vec2(0:NLEVMAX,0:NLEVMAX),e_vec3(0:NLEVMAX,0:NLEVMAX)
      Real*8 e_temp(0:NLEVMAX)

      Real*8 max_ij,mtemp,inv_max_ij,inv_a_ii,btemp,aaa,bbb

      Integer*4 k
      Integer*4 itemp,jtemp,ktemp
      Integer*4 ilist(0:NLEVMAX),jlist(0:NLEVMAX)
      Integer*4 imax,jmax
      Integer*4 MDIM

      Real*8    tlow,thigh,q
      Integer*4 tlowindex,thighindex
      
c---- Main

      Do iz = 0,IZMAX
         Do iy = 0,IYMAX
            Do ix = 0,IXMAX
               Do i = 0,NL(NS)-1 
                  
                  deltae = elev(i+1)-elev(i)
                  aaa = deltae/HC
                  bbb =B(ns,i,i+1)*2.0D0*aaa*aaa*deltae
     &                   /(Exp(deltae*INV_TREF)-1.0D0)

                  ss(i,ix,iy,iz) = dss2(i,ix,iy,iz)+bbb
c$$$                  If ((Niter.le.3)
c$$$     &             .or.
c$$$     &            (Abs(dss2(i,ix,iy,iz)).gt.(bbb*0.5D0)))
                  If ((Abs(dss2(i,ix,iy,iz)).gt.(bbb*0.5D0)))
     &                ss(i,ix,iy,iz) = dss(i,ix,iy,iz)

c$$$               ss(i,ix,iy,iz)=(ss(i,ix,iy,iz)+ss_prev(i,ix,iy,iz))*0.5D0

               End do
            End do
         End do
      End do

      Do iz = 0,IZMAX
         Do iy = 0,IYMAX
            Do ix = 0,IXMAX
c--- income is positive, outgo is negative for the i-th state.

c--- Calculate Collisional Rate from tk(ix,iy,iz). -> C(NS,i,j)
               
               If (tk(ix,iy,iz).gt.(TABLEMAX*10.0D0)) Then
                  write(*,*) "Kinetic temperature is too high!!"
                  Stop
               Endif

               If (tk(ix,iy,iz).lt.5.0D0) Then
                  write(*,*) "Kinetic temperature is too low!!"
                  Stop
               Endif

               tlowindex  = Int(tk(ix,iy,iz)*0.1D0)
               thighindex = tlowindex+1

               tlow  =  tlowindex*10.0D0
               thigh = thighindex*10.0D0
               
               If (tlow.eq.0.0D0) tlow = 5.0D0
               
 100           Continue

c---- Log Linier Interpolation
               Do i = 0,NL(NS)
                  C(NS,i,i) = 0.0D0
               End do

               q = (Log(tk(ix,iy,iz))-Log(tlow))/(Log(thigh)-Log(tlow))
               Do i = 1,NL(NS)
               Do j = 0,i-1
                     C(NS,i,j) = Exp( Log(CTABLE(tlowindex ,i,j))
     &                                                 *(1.0D0-q)
     &                            +Log(CTABLE(thighindex,i,j))*q)
                     
                  End do
               End do

               Do j = 1,NL(NS)
                  Do i = 0,j-1
                     C(NS,i,j) = C(NS,j,i)*GSTAT(j)/GSTAT(i)*
     &                        exp(-(elev(j)-elev(i))/(KB*tk(ix,iy,iz)))
                  End do
               End do

c---- The end of C(ix,iy,iz) calculation

               Do i = -1,NL(NS)+1
                  Do j = -1,NL(NS)+1
                     matrix(i,j) = 0.0D0
                  End do
               End do
      
               Do i = 0,NL(NS)
                  aaa = 0.0D0
                  Do j = 0,NL(NS)
                     
                     matrix(i,j) = C(NS,j,i)*ndens0(0,ix,iy,iz) 
                     aaa         = C(NS,i,j)*ndens0(0,ix,iy,iz)  + aaa
                     
                  End do
                  
         matrix(i,i+1) = matrix(i,i+1) 
     &           + A(NS,i+1,i)
     &           +ss(i  ,ix,iy,iz)*(2.0D0*i+1.0D0)/(2.0D0*i+3.0D0)
         matrix(i,i  ) = matrix(i,i  ) 
     &           - A(NS,i,i-1)
     &           -ss(i  ,ix,iy,iz)
     &           -ss(i-1,ix,iy,iz)*(2.0D0*i-1.0D0)/(2.0D0*i+1.0D0)
     &           -aaa

         matrix(i,i-1) = matrix(i,i-1) 
     &           + ss(i-1,ix,iy,iz)

      End do

      Do j = 0,NL(NS)

         matrix(NL(NS),j) = 1.0D0

         a_vec(j) = 0.0D0
         
      End do

      a_vec(NL(NS)) = ndens0(NS,ix,iy,iz)

      MDIM = NL(NS)

      Do i = 0,MDIM
         ilist(i) = i
         jlist(i) = i
      End do

         Do k = 0,MDIM
            
            max_ij = 0.0D0
            Do i = k,MDIM 
               Do j = k,MDIM
                  mtemp = Abs(matrix(i,j))
                  If (mtemp.gt.max_ij) Then
                     imax = i
                     jmax = j
                     max_ij = mtemp
                  Endif
               End do
            End do
            max_ij = matrix(imax,jmax)
            inv_max_ij = 1.0D0/(max_ij+Sign(EPSILON,max_ij))
            
            If ((imax.ne.k).or.(jmax.ne.k)) Then
               
               Do i = 0,MDIM
                  mtemp          = matrix(i,jmax)
                  matrix(i,jmax) = matrix(i,   k)
                  matrix(i,   k) = mtemp
               End do
               Do j = 0,MDIM
                  mtemp          = matrix(imax,j)
                  matrix(imax,j) = matrix(   k,j)
                  matrix(   k,j) = mtemp
               End do
               
               ktemp       = ilist(imax)
               ilist(imax) = ilist(k)
               ilist(k)    = ktemp
               ktemp       = jlist(jmax)
               jlist(jmax) = jlist(k)
               jlist(k)    = ktemp
               
            Endif
            
            Do i = k+1,MDIM
               matrix(i,k) = matrix(i,k)*inv_max_ij
            End do
            
            Do i = k+1,MDIM
               Do j = k+1,MDIM
                  matrix(i,j) = matrix(i,j) - matrix(k,j)*matrix(i,k)
               End do
            End do
            
         End do

         Do i = 0,MDIM
            Do k = 0,MDIM
               e_vec(i,k) = 0.0D0
               If(i.eq.k) e_vec(i,k) = 1.0D0
            End do
         End do

         Do i = 0,MDIM
            itemp = ilist(i)
             Do k = 0,MDIM
                  e_vec1(i,k) =     e_vec(itemp,k)
             End do
         End do

         Do i = 0,MDIM
            Do k = 0,MDIM
               e_temp(k) = 0.0D0
            End do
            Do j =  0,i-1
               Do k = 0,MDIM
                  e_temp(k) = e_temp(k) + matrix(i,j)*e_vec2(j,k)
               End do
            End do
            Do k = 0,MDIM
               e_vec2(i,k) =  e_vec1(i,k) -   e_temp(k)
            End do
         End do

         Do i = MDIM,0,-1
            Do k = 0,MDIM
               e_temp(k) = 0.0D0
            End do
            Do j = i+1,MDIM
               Do k = 0,MDIM
                  e_temp(k) =   e_temp(k) + matrix(i,j)*e_vec3(j,k)
               End do
            End do

            inv_a_ii = 1.0D0/(matrix(i,i)+Sign(EPSILON,matrix(i,i)))

            Do k = 0,MDIM
                e_vec3(i,k) = (  e_vec2(i,k) -   e_temp(k))*inv_a_ii
            End do

         End do
         
         Do j = 0,MDIM
            jtemp = jlist(j)

            Do k = 0,MDIM
                e_vec(jtemp,k) =   e_vec3(j,k)

            End do

         End do

         Do i = 0,MDIM

            btemp = 0.0D0

            Do j = 0,MDIM

               btemp =  btemp + a_vec(j)*e_vec(i,j)

            End do

            b_vec(i) = btemp

         End do
         
         Do i = 0,MDIM
            
            ndens_prev(NS,i,ix,iy,iz) = ndens(NS,i,ix,iy,iz)

            ndens(NS,i,ix,iy,iz) = b_vec(i)
            ndens(NS,i,ix,iy,iz) = 
     &               (b_vec(i) +  ndens_prev(NS,i,ix,iy,iz))*0.5D0

         End do
         
          End do
        End do
      End do

c----

      Do iz = 0,izmax
         Do iy = 0,iymax
            Do ix = 0,ixmax

               DO j=0,NL(NS)

                  ss_bk  (j,ix,iy,iz) = 0.0D0
                  ss_prev(j,ix,iy,iz) = ss(j,ix,iy,iz)

c---- For Ref Field
                  dss    (j,ix,iy,iz) = 0.0D0
                  dss2   (j,ix,iy,iz) = 0.0D0

c$$$c----Without Ref Field
c$$$                  ss     (j,ix,iy,iz) = 0.0D0
c$$$c----                  
               End do

            End do
         End do
      End do

      Return
      End 
