      Program MakesphereHCOplus
      Implicit NONE
      Include 'state.inc'
      Include 'netcdf.inc'
      
      Real*8 xwrite(1:IXMAX+1),ywrite(1:IYMAX+1),zwrite(1:IZMAX+1)

      Real*8 rhowrite(1:IXMAX+1,1:IYMAX+1,1:IZMAX+1)
      Real*8  vxwrite(1:IXMAX+1,1:IYMAX+1,1:IZMAX+1)
      Real*8  vywrite(1:IXMAX+1,1:IYMAX+1,1:IZMAX+1)
      Real*8  vzwrite(1:IXMAX+1,1:IYMAX+1,1:IZMAX+1)
      Real*8  tkwrite(1:IXMAX+1,1:IYMAX+1,1:IZMAX+1)
      Real*8    sigma(1:IXMAX+1,1:IYMAX+1,1:IZMAX+1)

      Integer ix,iy,iz
      Character*64 filename
      Integer idf,idn
      Integer idix,idiy,idiz
      Integer mstatus
      Integer IXM,IYM,IZM

      Real*8 TK_REF

c---- Main
      Call InputParameter
      Call SetupHCOplus

c---- When CDF file is written, the indix of array  starts from 0.

      Do ix = 0,IXMAX
         xwrite(ix+1) = x(ix)
      End do
      Do iy = 0,IYMAX
         ywrite(iy+1) = y(iy)
      End do
      Do iz = 0,IZMAX
         zwrite(iz+1) = z(iz)
      End do
      
      Do ix = 0,IXMAX
         Do iy = 0,IYMAX
            Do iz = 0,IZMAX
               
               rhowrite(ix+1,iy+1,iz+1) = ndens0(0,ix,iy,iz)
                vxwrite(ix+1,iy+1,iz+1) =     vx(  ix,iy,iz)
                vywrite(ix+1,iy+1,iz+1) =     vy(  ix,iy,iz)
                vzwrite(ix+1,iy+1,iz+1) =     vz(  ix,iy,iz)
                tkwrite(ix+1,iy+1,iz+1) =     tk(  ix,iy,iz)
                  sigma(ix+1,iy+1,iz+1) = 1.0D0/inv_sigma(ix,iy,iz)

            End do
         End do
      End do


c---- Output the initial vatiables with NetCDF.
      IXM = IXMAX+1
      IYM = IYMAX+1
      IZM = IZMAX+1

      filename = 'HCO+sphere.cdf'

      mstatus=nf_close(idf)

      call ncopn3d(idf,filename,idn,idix,IXM,idiy,IYM,idiz,IZM)
      call ncputosc(idf,'comment','HCO+sphere')

      call ncputos(idf,'XMAX',XMAX)
      call ncputos(idf,'YMAX',YMAX)
      call ncputos(idf,'ZMAX',ZMAX)
      call ncputos(idf,'XMIN',XMIN)
      call ncputos(idf,'YMIN',YMIN)
      call ncputos(idf,'ZMIN',ZMIN)

      call ncputo1(idf,idix,'x',xwrite,IXM)  
      call ncputo1(idf,idiy,'y',ywrite,IYM)  
      call ncputo1(idf,idiz,'z',zwrite,IZM)  

      call ncputo3(idf,idix,idiy,idiz,'rho',rhowrite,IXM,IYM,IZM)
      call ncputo3(idf,idix,idiy,idiz,'vx' , vxwrite,IXM,IYM,IZM)
      call ncputo3(idf,idix,idiy,idiz,'vy' , vywrite,IXM,IYM,IZM)
      call ncputo3(idf,idix,idiy,idiz,'vz' , vzwrite,IXM,IYM,IZM)
      call ncputo3(idf,idix,idiy,idiz,'tk' , tkwrite,IXM,IYM,IZM)
      call ncputo3(idf,idix,idiy,idiz,'sigma' ,sigma,IXM,IYM,IZM)

      mstatus=nf_close(idf)

c----
      
      Stop
      
      End
