;+
; IDL program for drawing spectra and chanel maps for
; a NetCDF data generated by nonLTE programs
;  ver.1.0  4/23/2003   K.Wada (wada.keiichi@nao.ac.jp)
;+
pro ncdfdraw

inputfile = 'DATAC0000.cdf'
print,'INPUT NetCDF data file name: ', inputfile


IF NCDF_EXISTS() EQ 0 THEN PRINT, 'NCDF not supported.'


fid=ncdf_open(inputfile,/nowrite)

a = ncdf_inquire(fid)
;help, a
print,'ncdf_inquire(ndims, nvars, ngatts, reddim) ', a

for i = 0, 12, 1 do begin
;    print, i, ncdf_varinq(fid, i)
endfor

ncdf_diminq,fid,0,name1,nx
ncdf_diminq,fid,1,name2,ny
ncdf_diminq,fid,2,name3,nz
;print,'number of dimensions: ', ndim
;print,name1,'=', nx
;print,name2,'=', ny
;print,name3,'=', nz
;print,'ncdf_dimid ix: ', ncdf_dimid(fid, 'ix')
;print,'ncdf_dimid iy: ', ncdf_dimid(fid, 'jx')
;print,'ncdf_dimid iz: ', ncdf_dimid(fid, 'kx')
;print,'ncdf_varid x:',  ncdf_varid(fid, 'x') 
;print,'ncdf_varid y:',  ncdf_varid(fid, 'y') 
;print,'ncdf_varid dv:',  ncdf_varid(fid, 'dv') 
;print,'ncdf_varid XMAX:',  ncdf_varid(fid, 'XMAX') 
;print,'ncdf_varid XMIN:',  ncdf_varid(fid, 'XMIN') 
;print,'ncdf_varid YMAX:',  ncdf_varid(fid, 'YMAX') 
;print,'ncdf_varid YMIN:',  ncdf_varid(fid, 'YMIN') 
;print,'ncdf_varid DVMAX:',  ncdf_varid(fid, 'DVMAX') 
;print,'ncdf_varid DVMIN:',  ncdf_varid(fid, 'DVMIN') 

ncdf_varget, fid, ncdf_varid(fid,'x'), x
;help,x
ncdf_varget, fid, ncdf_varid(fid,'y'), y
ncdf_varget, fid, ncdf_varid(fid,'dv'), dv
ncdf_varget, fid, ncdf_varid(fid,'dirx'), dirx
ncdf_varget, fid, ncdf_varid(fid,'diry'), diry
ncdf_varget, fid, ncdf_varid(fid,'dirz'), dirz
ncdf_varget, fid, ncdf_varid(fid,'XMAX'), xmax 
ncdf_varget, fid, ncdf_varid(fid,'XMIN'), xmin
 print,'XMAX, XMIN = ', xmax, xmin
ncdf_varget, fid, ncdf_varid(fid,'YMAX'), ymax 
ncdf_varget, fid, ncdf_varid(fid,'YMIN'), ymin
 print,'YMAX, YMIN = ', ymax, ymin
ncdf_varget, fid, ncdf_varid(fid,'DVMAX'), dvmax 
ncdf_varget, fid, ncdf_varid(fid,'DVMIN'), dvmin
 print,'DVMAX, DVMIN = ', dvmax, dvmin
ncdf_varget, fid, ncdf_varid(fid,'dirx'), dirx 
ncdf_varget, fid, ncdf_varid(fid,'diry'), diry 
ncdf_varget, fid, ncdf_varid(fid,'dirz'), dirz 
 print,'dirx,diry,dirz', dirx,diry,dirz
ncdf_varget, fid, ncdf_varid(fid,'x'), x 
ncdf_varget, fid, ncdf_varid(fid,'y'), y 
ncdf_varget, fid, ncdf_varid(fid,'dv'), dv 
ncdf_varget, fid, ncdf_varid(fid,'LV0000'), lv0 
ncdf_varget, fid, ncdf_varid(fid,'LV0001'), lv1 
ncdf_varget, fid, ncdf_varid(fid,'LV0002'), lv2 
ncdf_varget, fid, ncdf_varid(fid,'LV0003'), lv3 
ncdf_varget, fid, ncdf_varid(fid,'LV0004'), lv4 
ncdf_varget, fid, ncdf_varid(fid,'LV0005'), lv5 
ncdf_varget, fid, ncdf_varid(fid,'LV0010'), lv10 
ncdf_varget, fid, ncdf_varid(fid,'LV0020'), lv20 
;help, x 
;help, y 
;help, dv
;help, lv0
;help, lv10
;help, lv20

;for i= 0, nx-1 do begin 
; print, i, x(i), y(i), dv(i)
;endfor

;;;;;Spectrum for five transitions (1-0,2-1,3-2,4-3,5-4) ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xdata = indgen(31)
ydata = fltarr(31,5)
print,'Type position for which spectra are drawn.' 
print,'The positions should be in a range of -1<px<1 and -1<py<1.'
print,'e.g. px, py? 0.5 0.5' 
read, 'px, py? ', px, py
posx = 0 & posy = 0
posx = px* nx/2 + nx/2
posy = py* ny/2 + ny/2
for k= 0, nz-1,1 do begin 
 ;print, lv5(nx/2,ny/2,k)
 ydata(k,0) = lv0(posx,posy,k)
 ydata(k,1) = lv1(posx,posy,k)
 ydata(k,2) = lv2(posx,posy,k)
 ydata(k,3) = lv3(posx,posy,k)
 ydata(k,4) = lv4(posx,posy,k)
endfor
ymax = max(ydata)
ymin = min(ydata)
print,'ymax, ymin: ', ymax,ymin
window, 0, xsize=500,ysize=500, title='spectrum'
!p.region = [ 0., 0., 0.95, 0.95]
plot, dv/1e5, ydata(*,0)*1E13, xrange=[-5,5], yrange=[0., ymax*1E13], xtitle="Velocity (km s!u-1!n)", ytitle="Intensity (10!u-13!n erg s!u-1!n cm!u-2!n str!u-1 !nHz!u-1!n)", charsize=1.5, thick = 2
for i = 0, 4 do begin
oplot, dv/1e5, ydata(*,i)*1E13
endfor
xyouts, 0.55, 0.8, 'position: ',  /normal, charsize = 1.5
xyouts, 0.70, 0.8, string(px,format='(f3.1)'),  /normal, charsize = 1.5
xyouts, 0.80, 0.8, string(py,format='(f3.1)'), /normal, charsize = 1.5
;;;;;;; Chanel Map  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
print,'Select a transition for which a chanel map is drawn'
print,'0: J=1-0'  
print,'1: J=2-1'  
print,'2: J=3-2'  
print,'3: J=4-3'  
print,'4: J=5-4'  
jump: read,'0-4? ', ntrans
if (ntrans gt 4)then goto, jump 

print,'Enter velocity chanel in a range of '
print, min(dv)/1e5 * 0.9,'< v <', max(dv)/1e5 * 0.9
read,'v? ', vch
nzvc = nz*vch/10 + nz/2 -1 ; normalization

;print,'chanel number: ', nzvc

if (ntrans eq 0) then $  
  s_lv0 = extract_slice(lv0,nx,ny,nx/2,ny/2,nzvc,0,0,0,out_val=1e-10)
if (ntrans eq 1) then $  
  s_lv0 = extract_slice(lv1,nx,ny,nx/2,ny/2,nzvc,0,0,0,out_val=1e-10)
if (ntrans eq 2) then $  
  s_lv0 = extract_slice(lv2,nx,ny,nx/2,ny/2,nzvc,0,0,0,out_val=1e-10)
if (ntrans eq 3) then $  
  s_lv0 = extract_slice(lv3,nx,ny,nx/2,ny/2,nzvc,0,0,0,out_val=1e-10)
if (ntrans eq 4) then $  
  s_lv0 = extract_slice(lv4,nx,ny,nx/2,ny/2,nzvc,0,0,0,out_val=1e-10)

;help, s_lv0
;surface, s_lv0
;shade_surf, s_lv0, charsize=1.5
window, 2, xsize=500,ysize=500, title='chanel map'
loadct, 0
nlevels = 20
read,'number of contour levels? (default 20) ', nlevels
step = (max(s_lv0)* 0.99 - min(s_lv0)* 1.2 )/nlevels
vals = indgen(nlevels) * step + min(s_lv0)
contour, s_lv0, charsize=1.5, levels = vals, xtitle='X', ytitle = 'Y'
xyouts, 0.3, 0.95,'Chanel map for ', /normal,charsize = 1.5
xyouts, 0.6, 0.95,string(vch,format='(f5.2)') , /normal,charsize = 1.5
xyouts, 0.7, 0.95,'km s!u-1!n ', /normal,charsize = 1.5


if (ntrans eq 0) then trans_st = 'J=1-0' 
if (ntrans eq 1) then trans_st = 'J=2-1' 
if (ntrans eq 2) then trans_st = 'J=3-2' 
if (ntrans eq 3) then trans_st = 'J=4-3' 
if (ntrans eq 4) then trans_st = 'J=5-4' 

xyouts, 0.5, 0.9, trans_st, /normal,charsize = 1.5

;print,'ncdf_varid dirx:',  ncdf_varid(fid, 'dirx') 
;print,'ncdf_varid diry:',  ncdf_varid(fid, 'diry') 
;print,'ncdf_varid dirz:',  ncdf_varid(fid, 'dirz') 
;print,'ncdf_varid LV0029:',  ncdf_varid(fid, 'LV0029') 

print,'================='

return
end

