      Subroutine OutputCDF(Niter,IXM,IYM,IZM)
      Implicit NONE

      Include 'state.inc'
c---- Inputs
      Integer Niter
      Integer IXM,IYM,IZM

c---- local variables
      Integer*4 ix,iy,iz,i

      Real*8     xwrite(1:IXM),ywrite(1:IYM),zwrite(1:IZM)
      Real*8    vxwrite(1:IXM,1:IYM,1:IZM)
      Real*8    vywrite(1:IXM,1:IYM,1:IZM)
      Real*8    vzwrite(1:IXM,1:IYM,1:IZM) 
      Real*8   rhowrite(1:IXM,1:IYM,1:IZM)
      Real*8    tkwrite(1:IXM,1:IYM,1:IZM)
      Real*8      sigma(1:IXM,1:IYM,1:IZM) 
      Real*8 state(1:IXM,1:IYM,1:IZM)
      
      Integer*4 idf,idn
      Integer*4 idix,idiy,idiz
      Integer*4 mstatus

      Character*4 name
      Character*6 stname
      Character*7 fname1
      Character*11 fname2

      Include "netcdf.inc"
c---- main

      write(name,'(I4.4)') Niter
      fname1 = "ITR"//name
      fname2 = fname1//'.cdf'

      Do ix = 0,IXMAX
         xwrite(ix+1) = x(ix)
      End do
      Do iy = 0,IYMAX
         ywrite(iy+1) = y(iy)
      End do
      Do iz = 0,IZMAX
         zwrite(iz+1) = z(iz)
      End do
      Do iz = 0,IZMAX
         Do iy = 0,IYMAX
            Do ix = 0,IXMAX
               
                vxwrite(ix+1,iy+1,iz+1) =  vx(ix,iy,iz)
                vywrite(ix+1,iy+1,iz+1) =  vy(ix,iy,iz) 
                vzwrite(ix+1,iy+1,iz+1) =  vz(ix,iy,iz)
               rhowrite(ix+1,iy+1,iz+1) = ndens0(0,ix,iy,iz)
                tkwrite(ix+1,iy+1,iz+1) =  tk(ix,iy,iz)
                  sigma(ix+1,iy+1,iz+1) = 1.0D0
     &                             /inv_sigma(ix,iy,iz)

            End do
         End do
      End do

      mstatus=nf_open(fname2,0,idf)

      call ncopn3d(idf,fname2,idn,idix,IXM,idiy,IYM,idiz,IZM)

      call ncputosc(idf,'comment','Level Populations')
      
      call ncputosc(idf,'Used C Table',TABLENAME)
      call ncputos(idf,'Abundance',XC)
      call ncputos(idf,'Electric Dipole Momen',MU)
      call ncputos(idf,'Rotational Constant',BB)

      call ncputos(idf,'XMAX',XMAX)
      call ncputos(idf,'YMAX',YMAX)
      call ncputos(idf,'ZMAX',ZMAX)
      call ncputos(idf,'XMIN',XMIN)
      call ncputos(idf,'YMIN',YMIN)
      call ncputos(idf,'ZMIN',ZMIN)

      call ncputo1(idf,idix,'x',xwrite,IXM)  
      call ncputo1(idf,idiy,'y',ywrite,IYM)  
      call ncputo1(idf,idiz,'z',zwrite,IZM)  

      call ncputo3(idf,idix,idiy,idiz,'rho',rhowrite,IXM,IYM,IZM)
      call ncputo3(idf,idix,idiy,idiz,'vx' , vxwrite,IXM,IYM,IZM)
      call ncputo3(idf,idix,idiy,idiz,'vy' , vywrite,IXM,IYM,IZM)
      call ncputo3(idf,idix,idiy,idiz,'vz' , vzwrite,IXM,IYM,IZM)
      call ncputo3(idf,idix,idiy,idiz,'tk' , tkwrite,IXM,IYM,IZM)
      call ncputo3(idf,idix,idiy,idiz,'sigma' ,sigma,IXM,IYM,IZM)

      Do i = 0,NLEVMAX
         Do ix = 0,IXMAX
            Do iy = 0,IYMAX
               Do iz = 0,IZMAX

                  state(ix+1,iy+1,iz+1) = ndens(NS,i,ix,iy,iz)
                     
               End do
            End do
         End do

         write(name,'(I4.4)') i
         stname = "ST"//name
         call ncputo3(idf,idix,idiy,idiz,stname,state,IXM,IYM,IZM)

      End do

      mstatus=nf_close(idf)

c---- 

      End

      
      
